// Se da un sir cu n elemente.
// Query -urile sunt : 
//	0 p v   (adaugam v la poz p)
//  1 p1 p2 (se cere suma de la poz pe la poz p2)
#include <fstream>
using namespace std;
#define DIM 1000

ifstream fin("aib.in");
ofstream fout("aib.out");
 
int a[DIM]; // arborele de intervale
int n;

int Query(int poz)
{
	int s = 0;
	for ( int i = poz; i; i -= i & -i)
		s += a[i];
	return s;
}

void Update(int poz, int v)
{
	for ( int i = poz; i <= n; i += i & -i )
		a[i] += v;
}

int main()
{
	int v, m;
	fin >> n >> m;       // m - nr de intrebari 1 - update, 0 query
	for ( int i = 1; i <= n; ++i )
	{
		fin >> v;      // practic, nu memoram sirul de numere dat
		Update(i, v);  // updatam direct aib-ul (sirul a)
	}
	int c, p1, p2;
	for ( int i = 1; i <= m; ++i )
	{
		fin >> c;
		if ( c )
		{
			fin >> p1 >> v;
			Update(p1, v);
		}
		else
		{
			fin >> p1 >> p2;
			fout << Query(p2) - Query(p1 - 1) << '\n';
		}
	}
	
	fin.close();
	fout.close();
	return 0;
}
